loadt "cas.ml";;
CAS ();;

// Numerical evaluation
((3 + 4 DIV 2) EXP 3) * (5 MOD 3)

// Booleans
(3 divides 6) /\ EVEN 12

// Real evaluation
&1 + &22 / &2 - &1 * &2 pow 2

// Complex evaluation
(Cx(&1) + ii) pow 10 / Cx(&8) - Cx(&2) * ii
Re ((Cx (&3) + Cx (&2) * ii) / (Cx (-- &2) + Cx (&7) * ii))

// Symbolic simplification
x + &1 - x / &1 + &7 * (y + x) pow 2

// Derivative
diff (diff (\x. &3 * sin (&2 * x) + &7 + exp (exp x)))
diff (diff (\x. &3 * sin (&2 * x) + &7 + exp (exp x))) (&2)

// Finite sum
sum (0,5) (\x. &x * &x)

// Numerical approximation
N (&1 / &3) 8
N (sqrt (#5.123456789)) 8
N (dint (#0.1, #0.4) exp) 7

// Binominal
binom (40,15)

// Prime 
prime 23

// Integration
dint (&1, &2) sin
dint (&1, &2) (\x. x pow n)

// Combination of integration and diffrentiation
diff (\x. dint (x, x + &2) (\x. x pow 3))

// Vectors
(vector [&2; &2]:real^2) - vector [&1; &0] + vec 1
(vector[&2; &2]:real^2) + vector_mul (&2) (vector[&3; &0])

// Assumptions
assume(x > 1)
x > 0
sqrt(y * y)
y / y
assume(y > &1)
sqrt(y * y)
y / y
assume(z < &1)
y - z >= &0

// Commands
assumptions

// Listing assumptions concerning a single variable
about(x)

// All theorems proven in the current session
theorems

// Type assumptions
assume_type (k:int)
k + &1
k / k

// Assumptions for single simplifications
(sqrt (m * m) assuming m > &1) + sqrt (m * m)
sqrt (m * n) assuming m = n assuming n > &1
sqrt (m * n) assuming m = n /\ n > &1

// Contradictory assumptions
(sqrt (m * m) assuming m > &1) + (sqrt (m * m) assuming m < -- &1)
&1 = &0 assuming m > &0 assuming m < &0

// Rest are not working examples
diff inv
